/*
 * LOGICAL-PARADOX.ORG
 * Copyright (C)2006 satoshi akabane(akabane@logical-paradox.org)
 * $Id: RelationLessEqualOperation.java,v 1.3 2006/10/21 08:55:30 akabane Exp $
 */
package org.logical_paradox.petitbasic.operator.ro;

import org.logical_paradox.common.util.StringUtils;
import org.logical_paradox.petitbasic.lex.Token;
import org.logical_paradox.petitbasic.operator.Operation;
import org.logical_paradox.petitbasic.operator.OperationUtils;
import org.logical_paradox.petitbasic.runtime.BasicRuntimeContext;
import org.logical_paradox.petitbasic.runtime.exception.BasicLanguageException;
import org.logical_paradox.petitbasic.runtime.mathpack.Real;

/**
 * ֌WZq''
 * PQ菬ꍇ-1CłȂꍇ0ԋpD
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.3 $
 */
public class RelationLessEqualOperation implements Operation {
	/**
	 * ZsD
	 * @param ctx BASIC^CReLXg
	 * @param v1 P(PZq̏ꍇnull)
	 * @param v2 Q
	 * @return vZ
	 * @throws BasicLanguageException vZɔG[Ȃ
	 */
	public Token doOperation(BasicRuntimeContext context, Token v1, Token v2) throws BasicLanguageException {
		// ̌^̔r(vȂꍇType mismatch)
		int valueType = OperationUtils.compareValueType(v1, v2, context);
		boolean compareResult = false;

		if(valueType == OperationUtils.VTYPE_STR) {
			// ̏ꍇ͕ƂĔr
			compareResult = StringUtils.compare(v1.getStrValue(), v2.getStrValue()) <= 0;
		} else {
			// l̏ꍇ͎m̔r
			Real r1 = OperationUtils.realValue(v1, context);
			Real r2 = OperationUtils.realValue(v2, context);
			
			// r
			compareResult = context.config.mathpack.fp_CMPR(r1, r2) <= 0;
		}

		// rʂԂ(-1:true 0:false)
		Token token = new Token(Token.TYPE_LITERAL);
		token.setIntValue(compareResult ? -1 : 0);
		token.setValueType(Token.VTYPE_INT);

		return token;
	}

}
